VSTGUI: CDataBrowser Class Reference

VSTGUI 4.10 Graphical User Interface Framework not only for VST plugins

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Protected Types | List of all members
CDataBrowser Class Reference
Views » Controls

DataBrowser view. More...

`#include <cdatabrowser.h>`

Inheritance diagram for CDataBrowser:

## Classes
struct | Cell
| CDataBrowser Cell position description. More...

## Public Types
enum | CDataBrowserStyle { kDrawRowLines = 1 << kDrawRowLinesFlag , kDrawColumnLines = 1 << kDrawColumnLinesFlag , kDrawHeader = 1 << kDrawHeaderFlag , kMultiSelectionStyle = 1 << kMultiSelectionStyleFlag }
enum | { kNoSelection = -1 }
using | Selection = std::vector<int32_t>
Public Types inherited from CScrollView
enum | CScrollViewStyle { kHorizontalScrollbar = 1 << kHorizontalScrollbarFlag , kVerticalScrollbar = 1 << kVerticalScrollbarFlag , kDontDrawFrame = 1 << kDontDrawFrameFlag , kAutoDragScrolling = 1 << kAutoDragScollingFlag , kOverlayScrollbars = 1 << kOverlayScrollbarsFlag , kFollowFocusView = 1 << kFollowFocusViewFlag , kAutoHideScrollbars = 1 << kAutoHideScrollbarsFlag }
| Scroll View Style Flags. More...
enum class | Edge { Top , Left }
Public Types inherited from CViewContainer
using | ViewList = std::list<SharedPointer<CView>>
using | ChildViewConstIterator = ViewList::const_iterator
using | ChildViewConstReverseIterator = ViewList::const_reverse_iterator
enum class | MouseListenerCall { MouseDown , MouseMoved , MouseUp , MouseCancel }

## Public Member Functions
| CDataBrowser (const CRect &size, IDataBrowserDelegate *db, int32_t style=0, CCoord scrollbarWidth=16, CBitmap *pBackground=nullptr)
Public Member Functions inherited from CScrollView
| CScrollView (const CRect &size, const CRect &containerSize, int32_t style, CCoord scrollbarWidth=16, CBitmap *pBackground=nullptr)
int32_t | getStyle () const
void | setStyle (int32_t newStyle)
int32_t | getActiveScrollbars () const
CCoord | getScrollbarWidth () const
void | setScrollbarWidth (CCoord width)
virtual void | setContainerSize (const CRect &cs, bool keepVisibleArea=false)
| set the virtual size of this container
const CRect & | getContainerSize () const
const CPoint & | getScrollOffset () const
| get scroll offset
void | setScrollOffset (CPoint newOffset)
| set scroll offset
void | resetScrollOffset ()
CScrollbar * | getVerticalScrollbar () const
| get the vertical scrollbar
CScrollbar * | getHorizontalScrollbar () const
| get the horizontal scrollbar
virtual void | makeRectVisible (const CRect &rect)
| set scrollview to show rect
CRect | calculateOptimalContainerSize () const
| calculate the maximum rect where the scrollbars are inactive
CRect | getVisibleClientRect () const
| returns the visible rect of the client
void | setEdgeView (Edge edge, CView *view)
| set a static edge view
CView * | getEdgeView (Edge edge) const
bool | attached (CView *parent) override
| view is attached to a parent view
bool | addView (CView *pView, CView *pBefore=nullptr) override
| add a child view before another view
bool | removeView (CView *pView, bool withForget=true) override
| remove a child view
bool | removeAll (bool withForget=true) override
| remove all child views
uint32_t | getNbViews () const override
| get the number of child views
CView * | getView (uint32_t index) const override
| get the child view at index
bool | changeViewZOrder (CView *view, uint32_t newIndex) override
| change view z order position
void | drawBackgroundRect (CDrawContext *pContext, const CRect &_updateRect) override
| draw the background
void | onMouseWheelEvent (MouseWheelEvent &event) override
| called when a mouse wheel event occurs
void | valueChanged (CControl *pControl) override
void | setTransparency (bool val) override
| set views transparent state
void | setBackgroundColor (const CColor &color) override
| set the background color (will only be drawn if this container is not set to transparent and does not have a background bitmap)
void | setViewSize (const CRect &rect, bool invalid=true) override
| set views size
void | setAutosizeFlags (int32_t flags) override
| set autosize flags
CMessageResult | notify (CBaseObject *sender, IdStringPtr message) override
CBaseObject * | newCopy () const override
Public Member Functions inherited from CViewContainer
| CViewContainer (const CRect &size)
| CViewContainer constructor.
| CViewContainer (const CViewContainer &viewContainer)
bool | addView (CView *pView, const CRect &mouseableArea, bool mouseEnabled=true)
| add a child view
bool | isChild (CView *pView) const
| check if pView is a child view of this container
virtual bool | isChild (CView *pView, bool deep) const
| check if pView is a child view of this container
virtual bool | hasChildren () const
| check if container has child views
virtual CView * | getViewAt (const CPoint &where, const GetViewOptions &options=GetViewOptions()) const
| get the view at point where
virtual CViewContainer * | getContainerAt (const CPoint &where, const GetViewOptions &options=GetViewOptions().deep()) const
| get the container at point where
virtual bool | getViewsAt (const CPoint &where, ViewList &views, const GetViewOptions &options=GetViewOptions().deep()) const
| get all views at point where, top->down
virtual bool | hitTestSubViews (const CPoint &where, const Event &event)
virtual void | setAutosizingEnabled (bool state)
| enable or disable autosizing subviews.
bool | getAutosizingEnabled () const
template<class ViewClass, class ContainerClass>
uint32_t | getChildViewsOfType (ContainerClass &result, bool deep=false) const
| get child views of type ViewClass.
template<typename Proc>
void | forEachChild (Proc proc) const
| execute proc for each child view
template<typename Proc>
CView * | findFirstViewIf (Proc filter) const
void | setViewLayouter (const SharedPointer< IViewLayouter > &layouter)
| set a view layouter
SharedPointer< IViewLayouter > | getViewLayouter () const
| get the current view layouter
std::optional< ViewLayout > | calculateViewLayout (const CRect &newSize) const
| calculate the view layout for the new size
bool | applyViewLayout (const ViewLayout &layout)
| apply a previously calculated view layout
bool | inApplyViewLayout () const
| check if a view layout is currently applied
virtual CColor | getBackgroundColor () const
| get the background color
virtual void | setBackgroundOffset (const CPoint &p)
| set the offset of the background bitmap
virtual CPoint | getBackgroundOffset () const
| get the offset of the background bitmap
virtual void | setBackgroundColorDrawStyle (CDrawStyle style)
CDrawStyle | getBackgroundColorDrawStyle () const
void | setInitialFocusView (CView *view)
| set custom initial focus view which is first focused when advanceNextFocusView is called without oldFocus view
CView * | getInitialFocusView () const
| get custom initial focus view
virtual bool | advanceNextFocusView (CView *oldFocus, bool reverse=false)
virtual bool | invalidateDirtyViews ()
virtual CRect | getVisibleSize (const CRect &rect) const
void | setTransform (const CGraphicsTransform &t)
const CGraphicsTransform & | getTransform () const
void | registerViewContainerListener (IViewContainerListener *listener)
void | unregisterViewContainerListener (IViewContainerListener *listener)
void | draw (CDrawContext *pContext) override
void | drawRect (CDrawContext *pContext, const CRect &updateRect) override
void | onMouseDownEvent (MouseDownEvent &event) override
| called when a mouse down event occurs
void | onMouseMoveEvent (MouseMoveEvent &event) override
| called when a mouse move event occurs
void | onMouseUpEvent (MouseUpEvent &event) override
| called when a mouse up event occurs
void | onMouseCancelEvent (MouseCancelEvent &event) override
| called when mouse tracking should be canceled
void | onMouseWheelEvent (MouseWheelEvent &event) override
| called when a mouse wheel event occurs
void | onZoomGestureEvent (ZoomGestureEvent &event) override
| called when a zoom gesture event occurs
CMessageResult | notify (CBaseObject *sender, IdStringPtr message) override
bool | onWheel (const CPoint &where, const CMouseWheelAxis &axis, const float &distance, const CButtonState &buttons) final
SharedPointer< IDropTarget > | getDropTarget () override
| get the drag target for drag and drop handling
void | looseFocus () override
| called if view should loose focus
void | takeFocus () override
| called if view should take focus
bool | isDirty () const override
| check if view is dirty
void | invalid () override
| mark whole view as invalid
void | invalidRect (const CRect &rect) override
| mark rect as invalid
void | setViewSize (const CRect &rect, bool invalid=true) override
void | parentSizeChanged () override
| notification that one of the views parent has changed its size
bool | sizeToFit () override
| resize view to optimal size
bool | removed (CView *parent) override
| view is removed from parent view
bool | attached (CView *parent) override
| view is attached to a parent view
CPoint & | frameToLocal (CPoint &point) const override
| conversion from frame coordinates to local view coordinates
CPoint & | localToFrame (CPoint &point) const override
| conversion from local view coordinates to frame coordinates
CBaseObject * | newCopy () const override
CViewContainer * | asViewContainer () final
const CViewContainer * | asViewContainer () const final
Public Member Functions inherited from CView
| CView (const CRect &size)
| CView (const CView &view)
uint64_t | getRuntimeID () const
| get the unique runtime ID
virtual void | dispatchEvent (Event &event)
| dispatch an event
virtual void | onMouseEnterEvent (MouseEnterEvent &event)
| called when the mouse enters this view
virtual void | onMouseExitEvent (MouseExitEvent &event)
| called when the mouse leaves this view
virtual void | setMouseEnabled (bool bEnable=true)
| turn on/off mouse usage for this view
bool | getMouseEnabled () const
| get the state of wheather this view uses the mouse or not
virtual void | setMouseableArea (const CRect &rect)
| set the area in which the view reacts to the mouse
CRect | getMouseableArea () const
| get the area in which the view reacts to the mouse
virtual CMouseEventResult | onMouseUp (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseMoved (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseCancel ()
| do not use any longer.
virtual CMouseEventResult | onMouseEntered (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual CMouseEventResult | onMouseExited (CPoint &where, const CButtonState &buttons)
| do not use any longer.
virtual bool | onWheel (const CPoint &where, const float &distance, const CButtonState &buttons) final
CRect & | getMouseableArea (CRect &rect) const
| get the area in which the view reacts to the mouse
void | setHitTestPath (CGraphicsPath *path)
virtual bool | hitTest (const CPoint &where, const Event &event=noEvent())
| check if where hits this view
virtual bool | hitTest (const CPoint &where, const CButtonState &buttons)
bool | doDrag (const DragDescription &dragDescription, const SharedPointer< IDragCallback > &callback={})
| start a drag operation
void | setDropTarget (const SharedPointer< IDropTarget > &dt)
| set a custom drop target
DragResult | doDrag (IDataPackage *source, const CPoint &offset=CPoint(0, 0), CBitmap *dragBitmap=nullptr)
| a drag can only be started from within onMouseDown
virtual int32_t | onKeyDown (VstKeyCode &keyCode)
| called if a key down event occurs and this view has focus
virtual int32_t | onKeyUp (VstKeyCode &keyCode)
| called if a key up event occurs and this view has focus
CCoord | getHeight () const
| get the height of the view
CCoord | getWidth () const
| get the width of the view
const CRect & | getViewSize () const
| read only access to view size
virtual CRect | getVisibleViewSize () const
| returns the visible size of the view
int32_t | getAutosizeFlags () const
| get autosize flags
bool | getAttributeSize (const CViewAttributeID id, uint32_t &outSize) const
| get the size of an attribute
bool | getAttribute (const CViewAttributeID id, const uint32_t inSize, void *outData, uint32_t &outSize) const
| get an attribute
bool | setAttribute (const CViewAttributeID id, const uint32_t inSize, const void *inData)
| set an attribute
bool | removeAttribute (const CViewAttributeID id)
| remove an attribute
template<typename T>
bool | setAttribute (const CViewAttributeID id, const T &data)
| set an attribute
template<typename T>
bool | getAttribute (const CViewAttributeID id, T &data) const
| get an attribute
virtual void | setBackground (CBitmap *background)
| set the background image of this view
CBitmap * | getBackground () const
| get the background image of this view
virtual void | setDisabledBackground (CBitmap *background)
| set background image used when the mouse is not enabled
CBitmap * | getDisabledBackground () const
| get background image used when the mouse is not enabled
CBitmap * | getDrawBackground () const
| get the bitmap which is drawn depending on the enabled state.
bool | getTransparency () const
| get views transparent state
virtual void | setAlphaValue (float alpha)
| set alpha value which will be applied when drawing this view
float | getAlphaValue () const
| get alpha value
bool | isAttached () const
| is view attached to a parentView
void | setSubviewState (bool state)
bool | isSubview () const
CView * | getParentView () const
| get parent view
CFrame * | getFrame () const
| get frame
virtual VSTGUIEditorInterface * | getEditor () const
| get editor
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, CBaseObject *notificationObject)
void | addAnimation (IdStringPtr name, Animation::IAnimationTarget *target, Animation::ITimingFunction *timingFunction, const Animation::DoneFunction &doneFunc=nullptr, bool callDoneOnCancel=false)
void | removeAnimation (IdStringPtr name)
void | removeAllAnimations ()
void | registerViewListener (IViewListener *listener)
void | unregisterViewListener (IViewListener *listener)
void | registerViewEventListener (IViewEventListener *listener)
void | unregisterViewEventListener (IViewEventListener *listener)
void | registerViewMouseListener (IViewMouseListener *listener)
void | unregisterViewMouseListener (IViewMouseListener *listener)
CGraphicsTransform | getGlobalTransform (bool ignoreFrame=false) const
| get the active global transform for this view
template<typename T>
T & | translateToGlobal (T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
template<typename T>
T | translateToGlobal (const T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
template<typename T>
T & | translateToLocal (T &t, bool ignoreFrame=false) const
| translates a global coordinate to a local one using parent transforms
template<typename T>
T | translateToLocal (const T &t, bool ignoreFrame=false) const
| translates a local coordinate to a global one using parent transforms
CMouseEventResult | callMouseListener (MouseListenerCall type, CPoint pos, CButtonState buttons)
void | callMouseListenerEnteredExited (bool mouseEntered)
CBaseObject * | newCopy () const override
virtual bool | checkUpdate (const CRect &updateRect) const
virtual void | setDirty (bool val=true)
| set the view to dirty so that it is redrawn in the next idle.
virtual void | setVisible (bool state)
| set visibility state
bool | isVisible () const
| get visibility state
virtual void | onIdle ()
| called on idle when view wants idle
void | setWantsIdle (bool state)
| enable/disable onIdle() callback
bool | wantsIdle () const
| returns if the view wants idle callback or not
virtual bool | wantsWindowActiveStateChangeNotification () const
| whether this view wants to be informed if the window's active state changes
virtual void | onWindowActivate (bool state)
| called when the active state of the window changes
void | setTooltipText (UTF8StringPtr text)
Public Member Functions inherited from CBaseObject
| CBaseObject ()=default
| ~CBaseObject () noexcept override=default
| CBaseObject (const CBaseObject &)
CBaseObject & | operator= (const CBaseObject &)
Public Member Functions inherited from ReferenceCounted< int32_t >
| ReferenceCounted ()=default
virtual | ~ReferenceCounted () noexcept=default
| ReferenceCounted (const ReferenceCounted &)
ReferenceCounted & | operator= (const ReferenceCounted &)
| ReferenceCounted ()=default
| ReferenceCounted (const ReferenceCounted &)
virtual | ~ReferenceCounted () noexcept=default
ReferenceCounted & | operator= (const ReferenceCounted &)
void | forget () override
| decrease refcount and delete object if refcount == 0
void | remember () override
| increase refcount
virtual int32_t | getNbReference () const
| get refcount
void | forget () override
| decrease refcount and delete object if refcount == 0
void | remember () override
| increase refcount
virtual int32_t | getNbReference () const
| get refcount
Public Member Functions inherited from IControlListener
virtual | ~IControlListener () noexcept=default
virtual int32_t | controlModifierClicked (CControl *pControl, CButtonState button)
| return 1 if you want the control to not handle it, otherwise 0
virtual void | controlBeginEdit (CControl *pControl)
virtual void | controlEndEdit (CControl *pControl)
virtual void | controlTagWillChange (CControl *pControl)
virtual void | controlTagDidChange (CControl *pControl)
Public Member Functions inherited from ViewListenerAdapter
void | viewSizeChanged (CView *view, const CRect &oldSize) override
| called when the view's size changed
void | viewAttached (CView *view) override
| called when a view was attached to a view hierarchy
void | viewRemoved (CView *view) override
| called when a view was removed from the view hierarchy
void | viewLostFocus (CView *view) override
| called when a view lost focus
void | viewTookFocus (CView *view) override
| called when a view took focus
void | viewWillDelete (CView *view) override
| called when a view is going to be destroyed
void | viewOnMouseEnabled (CView *view, bool state) override
| called when a view's mouse handling is enabled or disabled
Public Member Functions inherited from IViewListener
virtual | ~IViewListener () noexcept=default

## Protected Types
enum | { kDrawRowLinesFlag = kLastScrollViewStyleFlag , kDrawColumnLinesFlag , kDrawHeaderFlag , kMultiSelectionStyleFlag }
Protected Types inherited from CScrollView
enum | { kHorizontalScrollbarFlag , kVerticalScrollbarFlag , kDontDrawFrameFlag , kAutoDragScollingFlag , kOverlayScrollbarsFlag , kFollowFocusViewFlag , kAutoHideScrollbarsFlag , kLastScrollViewStyleFlag }
Protected Types inherited from CViewContainer
enum | { kAutosizeSubviews = 1 << (CView::kLastCViewFlag + 1) , kInApplyLayout = 1 << (CView::kLastCViewFlag + 2) }
Protected Types inherited from CView
enum | { kMouseEnabled = 1 << 0 , kTransparencyEnabled = 1 << 1 , kWantsFocus = 1 << 2 , kIsAttached = 1 << 3 , kVisible = 1 << 4 , kDirty = 1 << 5 , kWantsIdle = 1 << 6 , kIsSubview = 1 << 7 , kHasAlpha = 1 << 8 , kHasBackground = 1 << 9 , kHasDisabledBackground = 1 << 10 , kHasMouseableArea = 1 << 11 , kLastCViewFlag = 11 }

## CDataBrowser Methods
IDataBrowserDelegate * | db
CDataBrowserView * | dbView
CDataBrowserHeader * | dbHeader
CViewContainer * | dbHeaderContainer
Selection | selection
virtual void | recalculateLayout (bool rememberSelection=false)
| trigger recalculation, call if numRows or numColumns changed
virtual void | invalidate (const Cell &cell)
| invalidates an individual cell
virtual void | invalidateRow (int32_t row)
| invalidates a complete row
virtual void | makeRowVisible (int32_t row)
| scrolls the scrollview so that row is visible
virtual CRect | getCellBounds (const Cell &cell)
| get bounds of a cell
virtual Cell | getCellAt (const CPoint &where) const
| get the cell at position where
virtual int32_t | getSelectedRow () const
| get first selected row
virtual void | setSelectedRow (int32_t row, bool makeVisible=false)
| set the exclusive selected row
const Selection & | getSelection () const
| get all selected rows
virtual void | selectRow (int32_t row)
| add row to selection
virtual void | unselectRow (int32_t row)
| remove row from selection
virtual void | unselectAll ()
| empty selection
virtual void | beginTextEdit (const Cell &cell, UTF8StringPtr initialText)
| starts a text edit for a cell
IDataBrowserDelegate * | getDelegate () const
| get delegate object
void | setAutosizeFlags (int32_t flags) override
| set autosize flags
void | setViewSize (const CRect &size, bool invalid) override
| set views size
void | setWantsFocus (bool state) override
| set focus support on/off
void | onKeyboardEvent (KeyboardEvent &event) override
| called when a keyboard event is dispatched to this view
CMouseEventResult | onMouseDown (CPoint &where, const CButtonState &buttons) override
| do not use any longer.
| ~CDataBrowser () noexcept override
void | valueChanged (CControl *pControl) override
CMessageResult | notify (CBaseObject *sender, IdStringPtr message) override
bool | attached (CView *parent) override
| view is attached to a parent view
bool | removed (CView *parent) override
| view is removed from parent view
bool | wantsFocus () const override
| check if view supports focus
void | validateSelection ()

## Additional Inherited Members
static bool | kDirtyCallAlwaysOnMainThread = false
| if this is true, setting a view dirty will call invalid() instead of checking it in idle.
static uint32_t | idleRate = 30
| global idle rate in Hz, defaults to 30 Hz
| ~CScrollView () noexcept override
void | recalculateLayout ()
void | preLayouting () const
void | syncScrollbars (bool keepVisibleArea)
void | syncHScrollbar (bool keepVisibleArea)
void | syncVScrollbar (bool keepVisibleArea)
void | viewSizeChanged (CView *view, const CRect &oldSize) override
| called when the view's size changed
void | viewWillDelete (CView *view) override
| called when a view is going to be destroyed
CScrollContainer * | getScrollContainer () const
| ~CViewContainer () noexcept override
void | beforeDelete () override
virtual bool | checkUpdateRect (CView *view, const CRect &rect)
| check if view needs to be updated for rect
void | setMouseDownView (CView *view)
CView * | getMouseDownView () const
const ViewList & | getChildren () const
| ~CView () noexcept override
CGraphicsPath * | getHitTestPath () const
bool | hasViewFlag (int32_t bit) const
void | setViewFlag (int32_t bit, bool state)
void | setAlphaValueNoInvalidate (float value)
void | setParentFrame (CFrame *frame)
void | setParentView (CView *parent)
static constexpr int32_t | kHSBTag = 0
static constexpr int32_t | kVSBTag = 1

## Detailed Description

DataBrowser view.

## Member Typedef Documentation

## ◆ Selection

using Selection = std::vector<int32_t>

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum
| protected

Enumerator
kDrawRowLinesFlag |
kDrawColumnLinesFlag |
kDrawHeaderFlag |
kMultiSelectionStyleFlag |

## ◆ anonymous enum

anonymous enum

Enumerator
kNoSelection |

## ◆ CDataBrowserStyle

enum CDataBrowserStyle

Enumerator
kDrawRowLines |
kDrawColumnLines |
kDrawHeader |
kMultiSelectionStyle |

## Constructor & Destructor Documentation

## ◆ CDataBrowser()

CDataBrowser | ( | const CRect & | size,
|  | IDataBrowserDelegate * | db,
|  | int32_t | style = 0,
|  | CCoord | scrollbarWidth = 16,
|  | CBitmap * | pBackground = nullptr )

Parameters

  size | size of data browser
  db | data browser interface. If db is inheritated from CBaseObject it will be remembered and released if data browser is destroyed
  style | data browser and scroll view style see CDataBrowserStyle and CScrollViewStyle
  scrollbarWidth | width of scrollbars
  pBackground | background bitmap

## ◆ ~CDataBrowser()

~CDataBrowser | ( |  | ) |
| overrideprotectednoexcept

## Member Function Documentation

## ◆ attached()

bool attached | ( | CView * | parent | ) |
| overrideprotectedvirtual

view is attached to a parent view

Parameters

  parent | parent view

Returns
  true if view successfully attached to parent

Reimplemented from CView.

## ◆ beginTextEdit()

void beginTextEdit | ( | const Cell & | cell,
|  | UTF8StringPtr | initialText )
| virtual

starts a text edit for a cell

Parameters

  cell | cell
  initialText | UTF-8 string the text edit field will be initialized with

## ◆ getCellAt()

CDataBrowser::Cell getCellAt | ( | const CPoint & | where | ) | const
| virtual

get the cell at position where

## ◆ getCellBounds()

CRect getCellBounds | ( | const Cell & | cell | ) |
| virtual

get bounds of a cell

Parameters

  cell | cell

Returns
  bounds of cell

## ◆ getDelegate()

IDataBrowserDelegate * getDelegate | ( |  | ) | const
| inline

get delegate object

## ◆ getSelectedRow()

int32_t getSelectedRow | ( |  | ) | const
| virtual

get first selected row

## ◆ getSelection()

const Selection & getSelection | ( |  | ) | const
| inline

get all selected rows

## ◆ invalidate()

void invalidate | ( | const Cell & | cell | ) |
| virtual

invalidates an individual cell

Parameters

  cell | cell to invalidate

## ◆ invalidateRow()

void invalidateRow | ( | int32_t | row | ) |
| virtual

invalidates a complete row

Parameters

  row | row to invalidate

## ◆ makeRowVisible()

void makeRowVisible | ( | int32_t | row | ) |
| virtual

scrolls the scrollview so that row is visible

Parameters

  row | row to make visible

## ◆ notify()

CMessageResult notify | ( | CBaseObject * | sender,
|  | IdStringPtr | message )
| overrideprotectedvirtual

Reimplemented from CBaseObject.

## ◆ onKeyboardEvent()

void onKeyboardEvent | ( | KeyboardEvent & | event | ) |
| overridevirtual

called when a keyboard event is dispatched to this view

This happens normally only if the view is the focus view.

Reimplemented from CView.

## ◆ onMouseDown()

CMouseEventResult onMouseDown | ( | CPoint & | where,
|  | const CButtonState & | buttons )
| overridevirtual

do not use any longer.

if possible refactor your classes to use the newer mouse event methods above.

Parameters

  where | mouse location of mouse down
  buttons | button and modifier state

Returns
  event result. see CMouseEventResult

Reimplemented from CView.

## ◆ recalculateLayout()

void recalculateLayout | ( | bool | rememberSelection = false | ) |
| virtual

trigger recalculation, call if numRows or numColumns changed

Parameters

  rememberSelection | if true selection will be remembered

## ◆ removed()

bool removed | ( | CView * | parent | ) |
| overrideprotectedvirtual

view is removed from parent view

Parameters

  parent | parent view

Returns
  true if view successfully removed from parent

Reimplemented from CView.

## ◆ selectRow()

void selectRow | ( | int32_t | row | ) |
| virtual

add row to selection

## ◆ setAutosizeFlags()

void setAutosizeFlags | ( | int32_t | flags | ) |
| overridevirtual

set autosize flags

Reimplemented from CView.

## ◆ setSelectedRow()

void setSelectedRow | ( | int32_t | index,
|  | bool | makeVisible = false )
| virtual

set the exclusive selected row

Parameters

  index | row to select
  makeVisible | if true makes row visible

## ◆ setViewSize()

void setViewSize | ( | const CRect & | newSize,
|  | bool | doInvalid )
| overridevirtual

set views size

Parameters

  newSize | rect of new size of view
  doInvalid | if true set view dirty

Reimplemented from CView.

## ◆ setWantsFocus()

void setWantsFocus | ( | bool | state | ) |
| overridevirtual

set focus support on/off

Reimplemented from CView.

## ◆ unselectAll()

void unselectAll | ( |  | ) |
| virtual

empty selection

## ◆ unselectRow()

void unselectRow | ( | int32_t | row | ) |
| virtual

remove row from selection

## ◆ validateSelection()

void validateSelection | ( |  | ) |
| protected

## ◆ valueChanged()

void valueChanged | ( | CControl * | pControl | ) |
| overrideprotectedvirtual

Implements IControlListener.

## ◆ wantsFocus()

bool wantsFocus | ( |  | ) | const
| overrideprotectedvirtual

check if view supports focus

Reimplemented from CView.

## Member Data Documentation

## ◆ db

IDataBrowserDelegate* db
| protected

## ◆ dbHeader

CDataBrowserHeader* dbHeader
| protected

## ◆ dbHeaderContainer

CViewContainer* dbHeaderContainer
| protected

## ◆ dbView

CDataBrowserView* dbView
| protected

## ◆ selection

Selection selection
| protected

The documentation for this class was generated from the following files:

- cdatabrowser.h
- cdatabrowser.cpp